"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.isem = exports.ispercentage = exports.ispixel = exports.isstring = exports.isnumber = exports.iscolor = undefined;

var _VariableNode = require("../tree/VariableNode");

var _VariableNode2 = _interopRequireDefault(_VariableNode);

var _convert = require("../tree/convert");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iscolor = exports.iscolor = function iscolor(value) {
    return new _VariableNode2.default("require('tinycolor2')(" + (0, _convert.convertNode)(value) + ").isValid().toString()");
};
var isnumber = exports.isnumber = function isnumber(value) {
    return new _VariableNode2.default("(!isNaN(parseFloat(" + (0, _convert.convertNode)(value) + "))).toString()");
};
var isstring = exports.isstring = function isstring(value) {
    return new _VariableNode2.default("(('' + " + (0, _convert.convertNode)(value) + ")[0] === '\"').toString()");
};
var ispixel = exports.ispixel = function ispixel(value) {
    return new _VariableNode2.default("(('' + " + (0, _convert.convertNode)(value) + ").endsWith(\"px\")).toString()");
};
var ispercentage = exports.ispercentage = function ispercentage(value) {
    return new _VariableNode2.default("(('' + " + (0, _convert.convertNode)(value) + ").endsWith(\"%\")).toString()");
};
var isem = exports.isem = function isem(value) {
    return new _VariableNode2.default("(('' + " + (0, _convert.convertNode)(value) + ").endsWith(\"em\")).toString()");
};