"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _detectors = require("../utils/detectors");

var _transpileLess = require("./transpileLess");

var _transpileLess2 = _interopRequireDefault(_transpileLess);

var _generator = require("@babel/generator");

var _generator2 = _interopRequireDefault(_generator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var regex = /`([\s\S]*)`/;

exports.default = function (path, state, _ref) {
    var t = _ref.types;

    if (!(0, _detectors.isStyled)(t)(path.node.tag, state)) {
        return;
    }

    // Find the TemplateLiteral in the TaggedTemplateExpression
    path.traverse({
        TemplateLiteral: function TemplateLiteral(p) {
            if (p.isClean) return;

            var rawSource = p.getSource();
            if (!rawSource) {
                var _generate = (0, _generator2.default)({
                    type: 'Program',
                    body: [p.node]
                }),
                    code = _generate.code;

                rawSource = code;
            }

            var _regex$exec = regex.exec(rawSource),
                _regex$exec2 = _slicedToArray(_regex$exec, 2),
                foo = _regex$exec2[0],
                source = _regex$exec2[1];

            if (!source) return;
            p.isClean = true;

            var raw = (0, _transpileLess2.default)(source, state.file.opts.filename);
            if (source !== raw) {
                p.replaceWithSourceString('`' + raw + '`');
            }
        }
    });
};